#!/usr/bin/perl
system "clear";

print "Welcome to VU1nteractive (vu-wanter-active)
--------------------------------------------
Version 1.00pre1 -- GPL -- patryk\@pakl.net\nType help for help.\n";
while (1==1) 
{
	print "VU1> ";
	$A = <STDIN>;
	if ($A eq "clear\n") { system "clear"; next; }	
	if (lc($A) eq "exit\n") { exit; }	
	if (lc($A) eq "quit\n") { exit; }	
	if (lc($A) eq "help\n") { showHelp(); next; }	
	writeCommandToVSMFile($A);
	prepareToRunVU1();
	runVU1AndView();

}


sub showHelp() 
{
	print "
vu1nteractive help
------------------
vu1nteractive is an interactive VU program.  It lets you execute commands
on the Playstation2 VU1 as they are typed.  This works because when the
VU stops executing -- as long as no other program uses it -- the registers
and memory stay the same.

vu1nteractive will become more and more useful to development, testing and
educational purposes.  Please send your suggestions and/or patches to
me.

Error messages are those emitted by the compiler; eventually vu1nteractive
will help interpret those commands.

To see something happen, try typing:  NOP  IADDIU VI02, VI00, 123

";

}

sub runVU1AndView 
{
	system "./a.out > /dev/null";
}

sub prepareToRunVU1 
{
	system "./compile.sh";
}


sub writeCommandToVSMFile 
{
	$command = $_[0];
	open (I, "blank.vsm");
	open (O, ">execute.vsm");
	while ($line = <I>) 
	{	
		chop $line;	
		if ($line eq "; COMMAND") {
			print O $command;
			if ($command ne "") { print $command; }
		}
		else 
		{
			print O $line."\n";
		}
	}
	close (I);
	close (O);	
}


